
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               Writing parameters to a .gms file the uncapacitated
%               facility location problem
% 
%               Author:         Brage Knudsen, ITK,
%               Date Modified:  10.09.14
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Set the number of clients m facilities n:

M = 20;      % Number of clients
N = 6;      % Number of facilities

% Generate random profit coefficients, c(i,j) and facility setup cost d(j)
% Use randi to generate positive integers up to a maximum value iMax

iMax    = 100;
C       = randi(iMax,M,N);
D       = randi(iMax,N,1);

%% Generating GAMS file

filename = 'UFLDataFileOv.gms';

display(['Filename:',filename]);

fp = fopen(filename,'w+'); % Filepointer
fprintf(fp,'\n* File generated: %s \n\n\n', date);

fprintf(fp,'set i customer    /i1*i%1.0f/;\n', M);
fprintf(fp,'set j facilities  /j1*j%1.0f/;\n\n\n', N);

fprintf(fp,'Table c(i,j) profit coefficients \n\t');
%fprintf(fp,'\t profit coefficients \n ');
    for j=1:N    
            fprintf(fp,' j%1.0f \t',j);
    end
    fprintf(fp,'\n');
    
    for i=1:M    
            fprintf(fp,'i%1.0f \t ',i);
            for j=1:N
                fprintf(fp,'%2.0f \t',C(i,j));
            end
    fprintf(fp,'\n');            
    end
    
fprintf(fp,';\n\n');
    

fprintf(fp,'Parameters d(j) cost for opening facilities / \n');
    for j=1:N
        fprintf(fp,'j%1.0f \t %2.0f \n',j, D(j));
    end
fprintf(fp,'/;\n\n');

fclose(fp);