
$ontext

  The Uncapacitated Facility Location Problem


  Brage Knudsen, ITK, Sep 2014


$offtext

* Including matrices for profit and costs, together with set definitions:

$include "UFLDataFileOv.gms";

* Definition of variables and constraints:
variables
   Z             objective variable
;

positive variable
   x(i,j)        fraction of demand for customer i satisfied by facililty j
;

binary variable
   y(j)          1 if facility j is opend 0 otherwise

;

equations
   OBJ                   objective
   DEMAND(i)             satisfacton of demand
   FORCINGCONST(i,j)     strong setup forcing constraints
   WEAKFORCINGCONST(j)   weak setup forcing constraints
;

* Constraints specifications:
OBJ..                    z =e= sum((i,j), c(i,j)*x(i,j)) - sum(j, d(j)*y(j));
DEMAND(i)..              sum(j, x(i,j)) =e= 1;
FORCINGCONST(i,j)..      x(i,j) =l= y(j);
WEAKFORCINGCONST(j)..    sum(i,x(i,j)) =l= card(i)*y(j);



option limrow    =       10;
* Requiring 0% duality gap at termination
option optcr     =       0;


* Poor MIP solver
*option MIP       =       BDMLP;

* State-of-the-art solver.
option MIP       =       CPLEX;


* Definition of which constraints to include in the problem:

*model UFL /OBJ,DEMAND,FORCINGCONST/;
model UFL /OBJ,DEMAND,WEAKFORCINGCONST/;

* Set to 1 if optionfile should be used, 0 otherwise.

UFL.optfile = 1;

* Solve MILP problem: use MIP to solve mixed integer problem, and rmip to solve
* LP relaxation only.
solve UFL maximizing Z using mip;

display y.l;
